
#ifndef __COOL_SOUND_H__
#define __COOL_SOUND_H__

#ifdef __cplusplus
extern "C" {
#endif

extern int  CoolSoundInit( int aSampleRate, int aChannels );
extern void CoolSoundDone();

/** \brief Returns the number of bytes actually copied to the buffer */
extern int CoolSoundPlay( char* aBuffer, int aSize );

/** \brief Stop the playback after the buffer is empty */
extern void CoolSoundStopWhenEmpty();

/** \brief Stop the playback as soon as possible */
extern void CoolSoundStop();

extern void CoolSoundPause( int aPause );

/** \brief Returns the number of bytes that could be played without blocking
    or 0 if buffer is nearly full */
extern int CoolSoundGetFreeSpace();

/** \brief Returns the number of milliseconds that will take to play the 
    content of the buffer completely */
extern float CoolSoundGetPlayBackTime();

extern int  CoolSoundGetVolume();
extern void CoolSoundSetVolume( int aVolume );
extern void CoolSoundMute( int aMute );

#ifdef __cplusplus
}
#endif

#endif

