
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/watchdog.h>

#include "TTGOWatchdog.h"

static int TTGOWDFile = -1;

int  TTGOWatchdogInit()
{
 // Opening watchdog file
 char tmpFileName[ 200 ];
 int  tmpTime = 20;

 if( -1 != TTGOWDFile )
 { // Already opened      
  return 0;
 }

 sprintf( tmpFileName, "/dev/%s", "watchdog" );
 if( -1 == ( TTGOWDFile = open( tmpFileName, O_RDWR ) ) )
 { // Error
  return TTGOWD_ERROR_CAN_NOT_OPEN_FILE;
 }

 if( -1 == ioctl( TTGOWDFile, WDIOC_SETTIMEOUT, &tmpTime ) )
 { // Error
  TTGOWatchdogDone();
  return TTGOWD_ERROR_IOCTL;
 }
}

int  TTGOWatchdogDone()
{
 if( -1 != TTGOWDFile )
 {
  write( TTGOWDFile, "V", 1 );
  close( TTGOWDFile );
  TTGOWDFile = -1;
  return 0;
 }
 else
  return TTGOWD_ERROR_WD_NOT_OPENED;
}

void TTGOWatchdogPing()
{
 if( -1 != TTGOWDFile )
 {
  write( TTGOWDFile, "\0", 1 );
 }
}
